require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_INTR_H_)) {
    eval 'sub _MACHINE_INTR_H_ () {1;}' unless defined(&_MACHINE_INTR_H_);
    require 'machine/psl.ph';
    eval 'sub CPU_NINTS () {32;}' unless defined(&CPU_NINTS);
    eval 'sub NIPL () {17;}' unless defined(&NIPL);
    eval 'sub IPL_NONE () {0;}' unless defined(&IPL_NONE);
    eval 'sub IPL_SOFTCLOCK () {1;}' unless defined(&IPL_SOFTCLOCK);
    eval 'sub IPL_SOFTNET () {2;}' unless defined(&IPL_SOFTNET);
    eval 'sub IPL_BIO () {3;}' unless defined(&IPL_BIO);
    eval 'sub IPL_NET () {4;}' unless defined(&IPL_NET);
    eval 'sub IPL_SOFTTTY () {5;}' unless defined(&IPL_SOFTTTY);
    eval 'sub IPL_TTY () {6;}' unless defined(&IPL_TTY);
    eval 'sub IPL_VM () {7;}' unless defined(&IPL_VM);
    eval 'sub IPL_AUDIO () {8;}' unless defined(&IPL_AUDIO);
    eval 'sub IPL_CLOCK () {9;}' unless defined(&IPL_CLOCK);
    eval 'sub IPL_STATCLOCK () {10;}' unless defined(&IPL_STATCLOCK);
    eval 'sub IPL_SCHED () {10;}' unless defined(&IPL_SCHED);
    eval 'sub IPL_HIGH () {10;}' unless defined(&IPL_HIGH);
    eval 'sub IPL_IPI () {11;}' unless defined(&IPL_IPI);
    eval 'sub IPL_NESTED () {12;}' unless defined(&IPL_NESTED);
    eval 'sub IST_NONE () {0;}' unless defined(&IST_NONE);
    eval 'sub IST_PULSE () {1;}' unless defined(&IST_PULSE);
    eval 'sub IST_EDGE () {2;}' unless defined(&IST_EDGE);
    eval 'sub IST_LEVEL () {3;}' unless defined(&IST_LEVEL);
    if(defined(&MULTIPROCESSOR)) {
	eval 'sub HPPA_IPI_NOP () {0;}' unless defined(&HPPA_IPI_NOP);
	eval 'sub HPPA_IPI_HALT () {1;}' unless defined(&HPPA_IPI_HALT);
	eval 'sub HPPA_IPI_FPU_SAVE () {2;}' unless defined(&HPPA_IPI_FPU_SAVE);
	eval 'sub HPPA_IPI_FPU_FLUSH () {3;}' unless defined(&HPPA_IPI_FPU_FLUSH);
	eval 'sub HPPA_NIPI () {4;}' unless defined(&HPPA_NIPI);
    }
    if(!defined(&_LOCORE)  && defined(&_KERNEL)) {
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub splassert {
	        my($__wantipl) = @_;
    		eval q( &do {  &if ( &splassert_ctl > 0) {  &splassert_check($__wantipl,  &__func__); } }  &while (0));
	    }' unless defined(&splassert);
	    eval 'sub splsoftassert {
	        my($__wantipl) = @_;
    		eval q( &splassert($__wantipl));
	    }' unless defined(&splsoftassert);
	} else {
	    eval 'sub splassert {
	        my($__wantipl) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&splassert);
	    eval 'sub splsoftassert {
	        my($__wantipl) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&splsoftassert);
	}
	eval 'sub spllower {
	    my($ncpl) = @_;
    	    eval q({  &register \'int\'  &ocpl  &asm(\\"r28\\") = $ncpl;  &__asm  &__volatile(\\"copy  %0, %%arg0\\\\n\\\\tbreak %1, %2\\" : \\"+r\\" ( &ocpl) : \\"i\\" ( &HPPA_BREAK_KERNEL), \\"i\\" ( &HPPA_BREAK_SPLLOWER) : \\"r26\\", \\"memory\\"); ( &ocpl); });
	}' unless defined(&spllower);
	eval 'sub splraise {
	    my($ncpl) = @_;
    	    eval q({ \'struct cpu_info\' * &ci =  &curcpu(); \'int\'  &ocpl =  ($ci->{ci_cpl});  &if ( &ocpl < $ncpl)  ($ci->{ci_cpl}) = $ncpl;  &__asm  &__volatile (\\"sync\\" : \\"+r\\" ( ($ci->{ci_cpl}))); ( &ocpl); });
	}' unless defined(&splraise);
	eval 'sub splx {
	    my($ncpl) = @_;
    	    eval q({ ( &void) &spllower($ncpl); });
	}' unless defined(&splx);
	eval 'sub hppa_intr_disable {
	    my($void) = @_;
    	    eval q({  &register_t  &eiem;  &__asm  &__volatile(\\"mfctl %%cr15, %0\\": \\"=r\\" ( &eiem));  &__asm  &__volatile(\\"mtctl %r0, %cr15\\");  &eiem; });
	}' unless defined(&hppa_intr_disable);
	eval 'sub hppa_intr_enable {
	    my($eiem) = @_;
    	    eval q({  &__asm  &__volatile(\\"mtctl %0, %%cr15\\":: \\"r\\" ($eiem)); });
	}' unless defined(&hppa_intr_enable);
	eval 'sub splsoftclock () {
	    eval q( &splraise( &IPL_SOFTCLOCK));
	}' unless defined(&splsoftclock);
	eval 'sub splsoftnet () {
	    eval q( &splraise( &IPL_SOFTNET));
	}' unless defined(&splsoftnet);
	eval 'sub splbio () {
	    eval q( &splraise( &IPL_BIO));
	}' unless defined(&splbio);
	eval 'sub splnet () {
	    eval q( &splraise( &IPL_NET));
	}' unless defined(&splnet);
	eval 'sub splsofttty () {
	    eval q( &splraise( &IPL_SOFTTTY));
	}' unless defined(&splsofttty);
	eval 'sub spltty () {
	    eval q( &splraise( &IPL_TTY));
	}' unless defined(&spltty);
	eval 'sub splvm () {
	    eval q( &splraise( &IPL_VM));
	}' unless defined(&splvm);
	eval 'sub splaudio () {
	    eval q( &splraise( &IPL_AUDIO));
	}' unless defined(&splaudio);
	eval 'sub splclock () {
	    eval q( &splraise( &IPL_CLOCK));
	}' unless defined(&splclock);
	eval 'sub splsched () {
	    eval q( &splraise( &IPL_SCHED));
	}' unless defined(&splsched);
	eval 'sub splstatclock () {
	    eval q( &splraise( &IPL_STATCLOCK));
	}' unless defined(&splstatclock);
	eval 'sub splhigh () {
	    eval q( &splraise( &IPL_HIGH));
	}' unless defined(&splhigh);
	eval 'sub splipi () {
	    eval q( &splraise( &IPL_IPI));
	}' unless defined(&splipi);
	eval 'sub spl0 () {
	    eval q( &spllower( &IPL_NONE));
	}' unless defined(&spl0);
	eval 'sub softintr {
	    my($mask) = @_;
    	    eval q( &atomic_setbits_long( &curcpu()-> &ci_ipending, $mask));
	}' unless defined(&softintr);
	eval 'sub SOFTINT_MASK () {((1<< ( &IPL_SOFTCLOCK - 1)) | (1<< ( &IPL_SOFTNET - 1)) | (1<< ( &IPL_SOFTTTY - 1)));}' unless defined(&SOFTINT_MASK);
	if(defined(&MULTIPROCESSOR)) {
	}
	eval 'sub setsoftast {
	    my($p) = @_;
    	    eval q(( ($p->{p_md}->{md_astpending}) = 1));
	}' unless defined(&setsoftast);
	if(defined(&MULTIPROCESSOR)) {
	}
    }
}
1;
